from ox_script import *
import re
import os
import datetime
import openpyxl

form_list = []
selected_form = ""
serial_num_controller = None
current_workbook = None
current_worksheet = None
current_filepath = None
current_worksheet_line = 2
serial = None

def update_print_num(value):
    if not value.isdigit():
        starting_position_controller.update("必须是数字！")


def find_forms():
    global selected_form
    global form_list
    form_list = [file for file in os.listdir() if file.endswith(".txt")]
    if len(form_list) != 0:
        selected_form = form_list[0]


def update_selected_form(value):
    global form_list
    global selected_form
    selected_form = form_list[int(value)]
    current_datetime = datetime.datetime.now()
    formatted_datetime = current_datetime.strftime("%Y-%m-%d-%H%M%S")
    create_excel(selected_form + formatted_datetime)

def create_excel(filename):
    global current_workbook
    global current_worksheet
    global current_filepath
    global current_worksheet_line
    current_workbook = openpyxl.Workbook()
    current_worksheet = current_workbook.active
    current_path = os.getcwd()
    current_filepath = os.path.join(current_path, filename)
    current_workbook.save(current_filepath)
    current_worksheet_line = 2

def excel_record(barcode, serial_num=None):
    global current_workbook
    global current_worksheet
    global current_worksheet_line
    global current_filepath
    global serial
    current_worksheet['A' + str(current_worksheet_line)] = str(current_worksheet_line)
    current_worksheet['B' + str(current_worksheet_line)] = barcode
    if(serial != None):
        current_worksheet['C' + str(current_worksheet_line)] = serial_num
    current_worksheet['D' + str(current_worksheet_line)] = datetime.datetime.now()
    current_worksheet_line += 1
    current_workbook.save(current_filepath)

def checkIOPort():
    if(PTK_GetExternIOLevel(0) == "1"):
        return 0
    elif(PTK_GetExternIOLevel(1) == "1"):
        return 1
    elif(PTK_GetExternIOLevel(2) == "1"):
        return 2
    else:
        return -1

def increment_serial(serial):
    if int(starting_position_controller.value) != 1:    #不是最后一位开始序列号先拆分
        right_Characters=serial[-(int(starting_position_controller.value)-1):]
        serial =serial[:-(int(starting_position_controller.value)-1)]

    match = re.search(r'([A-Za-z]+)(\d+)$', serial)
    if match:   #先判断是不是里面有字母，如果是就拆分
        letters =serial[:-len(match.group(2))]
        number = int(match.group(2))
        new_number = number + 1
        new_serial= f"{letters}{new_number:0{len(match.group(2))}d}"
    else:
        new_serial=str(int(serial) + 1)
    if int(starting_position_controller.value) != 1:
        new_serial=new_serial+right_Characters
    return new_serial

# If the script is being run as the main program
if __name__ == "__main__":
    find_forms()
    PTK_UIInit(
        PTK_UIPage(
            form_list_controller := PTK_UIList(
                title="模板名称",
                items=form_list,
                valueType="int",
                value=0,
                Onpressed=update_selected_form,
            ),
            serial_num_controller := PTK_UIInput(
                title="序列号", value="FM20240108001A301W6371", Onsubmit=lambda x: None
            ),
            starting_position_controller :=PTK_UIInput(
                title="序列号起始位（从右往左）", value="1", Onsubmit=update_print_num
            ),
            barcode_controller := PTK_UIInput(
                title="条码", enabled=False, value="", Onsubmit=lambda x: None
            ),
        ),
        require_execute_confirmation=False
    )
    current_datetime = datetime.datetime.now()
    formatted_datetime = current_datetime.strftime("%Y-%m-%d-%H%M%S")
    create_excel(selected_form + str(formatted_datetime) + ".xlsx")
    while True:
        scanned = PTK_GetPortData(PORT_USBHOST, timeout=100)
        if scanned != -1:
            barcode_controller.update(scanned)
            IOinput = -1
            while(IOinput < 0):
                IOinput = checkIOPort() 
            if IOinput == 0:
                #print("io = 0")
                serial = serial_num_controller.value
                cmd = PTK_UpdateAllFormVariables(
                    selected_form,
                    Input1=serial
                )
                PTK_SendCmdToPrinter(cmd)
                serial_num_controller.update(increment_serial(serial))
                excel_record(scanned, serial_num=serial)
            elif IOinput == 1:
               # print("io = 1")
                excel_record(scanned)
            elif IOinput == 2:
               # print("io = 2")
                pass
            

                

